package com.n0tice.api.client.model;

import java.io.Serializable;
import java.util.Date;
import java.util.List;
import java.util.Map;

public class Content implements Serializable {

	private static final long serialVersionUID = 1L;

	private String id;
	private String apiUrl;
	private String webUrl;
	private String type;
	private String headline;
	private Place place;
	private User user;
	private String noticeboard;
	private Date created;
	private Date modified;
	private List<Tag> tags;
	private List<Update> updates;
	
	private Date startDate;
	private Date endDate;
	private Reoccurence reoccurs;
	private Date reoccursTo;	
	private int reposts;
	private Boolean awaitingModeration;
	private String moderationStatus;
	private String internalModerationStatus;
	private int moderationFlags;
	private int moderationNotes;
	private Map<String, Integer> votes;

	public Content() {
	}
	
	public Content(String id, String apiUrl, String webUrl, String type,
			String headline, Place place, User user, String noticeboard,
			Date created, Date modified, List<Tag> tags, List<Update> updates, Date startDate, Date endDate, 
			Reoccurence reoccurs, Date reoccursTo, int reposts, Boolean awaitingModeration, String moderationStatus, 
			String internalModerationStatus, int moderationFlags, int moderationNotes) {
		this.id = id;
		this.apiUrl = apiUrl;
		this.webUrl = webUrl;
		this.type = type;
		this.headline = headline;
		this.place = place;
		this.user = user;
		this.noticeboard = noticeboard;
		this.created = created;
		this.modified = modified;
		this.tags = tags;
		this.updates = updates;
		this.startDate = startDate;
		this.endDate = endDate;
		this.reoccurs = reoccurs;
		this.reoccursTo = reoccursTo;
		this.reposts = reposts;
		this.awaitingModeration = awaitingModeration;
		this.moderationStatus = moderationStatus;
		this.internalModerationStatus = internalModerationStatus;
		this.moderationFlags = moderationFlags;
		this.moderationNotes = moderationNotes;
	}

	public String getId() {
		return id;
	}

	public String getApiUrl() {
		return apiUrl;
	}

	public String getWebUrl() {
		return webUrl;
	}

	public String getType() {
		return type;
	}

	public String getHeadline() {
		return headline;
	}

	public Place getPlace() {
		return place;
	}

	public User getUser() {
		return user;
	}
	
	public String getNoticeboard() {
		return noticeboard;
	}
	
	public Date getCreated() {
		return created;
	}

	public Date getModified() {
		return modified;
	}

	public List<Tag> getTags() {
		return tags;
	}
	
	public List<Update> getUpdates() {
		return updates;
	}

	public Date getStartDate() {
		return startDate;
	}

	public Date getEndDate() {
		return endDate;
	}
	
	public Reoccurence getReoccurs() {
		return reoccurs;
	}

	public Date getReoccursTo() {
		return reoccursTo;
	}
	
	public int getReposts() {
		return reposts;
	}
	
	public Boolean isAwaitingModeration() {
		return awaitingModeration;
	}
	
	public String getModerationStatus() {
		return moderationStatus;
	}
	
	public int getModerationFlags() {
		return moderationFlags;
	}
	
	public String getInternalModerationStatus() {
		return internalModerationStatus;
	}
	
	public int getModerationNotes() {
		return moderationNotes;
	}

	public Map<String, Integer> getVotes() {
		return votes;
	}

	@Override
	public String toString() {
		return "Content [id=" + id + ", apiUrl=" + apiUrl + ", webUrl="
				+ webUrl + ", type=" + type + ", headline=" + headline
				+ ", place=" + place + ", user=" + user + ", noticeboard="
				+ noticeboard + ", created=" + created + ", modified="
				+ modified + ", tags=" + tags + ", updates=" + updates
				+ ", startDate=" + startDate + ", endDate=" + endDate
				+ ", reoccurence=" + reoccurs + ", reoccursTo=" + reoccursTo
				+ ", reposts=" + reposts + ", awaitingModeration="
				+ awaitingModeration + ", moderationStatus=" + moderationStatus
				+ ", internalModerationStatus=" + internalModerationStatus
				+ ", moderationFlags=" + moderationFlags + ", moderationNotes="
				+ moderationNotes + "]";
	}
	
}
