package com.n0tice.api.client.model;

import java.io.Serializable;
import java.util.List;
import java.util.Map;

public class MediaInfo implements Serializable {

	private static final long serialVersionUID = 1L;

	private Integer width;
	private Integer height;
	private String duration;
	private Integer orientation;

	private List<Map<String, String>> tracks;
	
	public MediaInfo() {
	}
	
	public MediaInfo(Integer width, Integer height, String duration, Integer orientation, List<Map<String, String>> tracks) {
		this.width = width;
		this.height = height;
		this.duration = duration;
		this.orientation = orientation;
		this.tracks = tracks;
	}

	public Integer getWidth() {
		return width;
	}

	public Integer getHeight() {
		return height;
	}

	public String getDuration() {
		return duration;
	}
	
	public Integer getOrientation() {
		return orientation;
	}
	
	public List<Map<String, String>> getTracks() {
		return tracks;
	}

	@Override
	public String toString() {
		return "MediaInfo [duration=" + duration + ", height=" + height
				+ ", orientation=" + orientation + ", tracks=" + tracks
				+ ", width=" + width + "]";
	}
	
}
