package com.n0tice.api.client.model;

import java.io.Serializable;
import java.util.Date;
import java.util.Set;

import org.joda.time.DateTime;

public class Noticeboard implements Serializable {
	
	private static final long serialVersionUID = 1L;
	
	private String domain;
	private String name;
	private String description;
	private Image background;
	private Image cover;
	private Date endDate;
	private Date embargoDate;
	private Group group;
	private Set<MediaType> supportedMediaTypes;
	private int contributors;
	private int contributions;
	private boolean moderated;
	private boolean featured;
	private boolean isolated;
	
	public Noticeboard() {
	}

	public Noticeboard(String domain, String name, String description,
			Image background, Image cover, Date endDate, Date embargoDate, Group group,
			Set<MediaType> supportedMediaTypes, int contributors, int contributions, boolean moderated, boolean featured, boolean isolated) {
		this.domain = domain;
		this.name = name;
		this.description = description;
		this.background = background;
		this.cover = cover;
		this.endDate = endDate;
		this.embargoDate = embargoDate;
		this.group = group;
		this.supportedMediaTypes = supportedMediaTypes;
		this.contributors = contributors;
		this.contributions = contributions;
		this.moderated = moderated;
		this.featured = featured;
		this.isolated = isolated;
	}

	public String getDomain() {
		return domain;
	}

	public String getName() {
		return name;
	}

	public String getDescription() {
		return description;
	}
	
	public Image getBackground() {
		return background;
	}

	public Image getCover() {
		return cover;
	}
	
	public Date getEndDate() {
		return endDate;
	}
	
	public Date getEmbargoDate() {
		return embargoDate;
	}

	public Group getGroup() {
		return group;
	}
	
	public Set<MediaType> getSupportedMediaTypes() {
		return supportedMediaTypes;
	}
	
	public int getContributors() {
		return contributors;
	}
	
	public int getContributions() {
		return contributions;
	}

	public boolean isModerated() {
		return moderated;
	}
	
	public boolean isFeatured() {
		return featured;
	}
	
	public boolean isIsolated() {
		return isolated;
	}
	
	public boolean isOpen() {
		return endDate == null || endDate.after(DateTime.now().toDate());		
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((domain == null) ? 0 : domain.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		Noticeboard other = (Noticeboard) obj;
		if (domain == null) {
			if (other.domain != null)
				return false;
		} else if (!domain.equals(other.domain))
			return false;
		return true;
	}

	@Override
	public String toString() {
		return "Noticeboard [background=" + background + ", contributions="
				+ contributions + ", contributors=" + contributors + ", cover="
				+ cover + ", description=" + description + ", domain=" + domain
				+ ", embargoDate=" + embargoDate + ", endDate=" + endDate
				+ ", featured=" + featured + ", group=" + group + ", isolated="
				+ isolated + ", moderated=" + moderated + ", name=" + name
				+ ", supportedMediaTypes=" + supportedMediaTypes + "]";
	}
	
}
