package com.n0tice.api.client.model;

import java.io.Serializable;
import java.util.List;
import java.util.Map;

public class ResultSet implements Serializable {
	
	private static final long serialVersionUID = 1L;

	private int numberFound;
	private int startIndex;
	private List<Content> results;
	private Map<String, Map<String, Integer>> refinements;
	
	public ResultSet() {
	}
	
	public ResultSet(int totalMatches, int startIndex, List<Content> results, Map<String, Map<String, Integer>> refinements) {
		this.numberFound = totalMatches;
		this.startIndex = startIndex;
		this.results = results;
		this.refinements = refinements;
	}

	public List<Content> getResults() {
		return results;
	}

	public int getNumberFound() {
		return numberFound;
	}

	public int getStartIndex() {
		return startIndex;
	}

	public Map<String, Map<String, Integer>> getRefinements() {
		return refinements;
	}

	@Override
	public String toString() {
		return "ResultSet [results=" + results + ", refinements=" + refinements
				+ ", startIndex=" + startIndex + ", numberFound="
				+ numberFound + "]";
	}
	
}
