package com.n0tice.api.client.model;

import java.io.Serializable;
import java.util.Map;

public class User implements Serializable {
	
	private static final long serialVersionUID = 1L;
	
	private String username;
	private String displayName;
	private String bio;
	private Image image;
	private Integer noticeboards;
	private Map<String, Integer> following;
	private String via;
	private String role;
	
	public User() {
	}
	
	public User(String username) {
		this.username = username;
	}

	public User(String username, String displayName, String bio, Image image, Integer noticeboards) {
		this.username = username;
		this.displayName = displayName;
		this.bio = bio;
		this.image = image;
		this.noticeboards = noticeboards;
	}
	
	public String getUsername() {
		return username;
	}

	public String getDisplayName() {
		return displayName;
	}
	
	public String getBio() {
		return bio;
	}

	public Image getProfileImage() {
		return image;
	}
	
	public Integer getNoticeboards() {
		return noticeboards;
	}
	
	public Map<String, Integer> getFollowing() {
		return following;
	}

	public void setFollowing(Map<String, Integer> following) {
		this.following = following;
	}
	
	public Image getImage() {
		return image;
	}

	public void setImage(Image image) {
		this.image = image;
	}

	public String getVia() {
		return via;
	}

	public void setVia(String via) {
		this.via = via;
	}
	
	public String getRole() {
		return role;
	}
	
	@Override
	public String toString() {
		return "User [username=" + username + ", displayName=" + displayName
				+ ", bio=" + bio + ", image=" + image + ", noticeboards="
				+ noticeboards + ", following=" + following + ", via=" + via
				+ ", role=" + role + "]";
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result
				+ ((username == null) ? 0 : username.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		User other = (User) obj;
		if (username == null) {
			if (other.username != null)
				return false;
		} else if (!username.equals(other.username))
			return false;
		return true;
	}
	
}
