package com.n0tice.api.client.parsers;

import java.util.Map;

import com.fasterxml.jackson.core.type.TypeReference;
import com.fasterxml.jackson.databind.DeserializationFeature;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.n0tice.api.client.exceptions.ParsingException;

public class ExifParser {

	private ObjectMapper mapper;

	public ExifParser() {
		mapper = new ObjectMapper();
        mapper.configure(DeserializationFeature.FAIL_ON_UNKNOWN_PROPERTIES, false);
	}
	
	public Map<String, Map<String, String>> parse(String json) throws ParsingException {
		try {
			return mapper.readValue(json, new TypeReference<Map<String, Map<String, String>>>(){});
		} catch (Exception e) {
			throw new ParsingException(e.getMessage());
		}
	}

}
