package com.n0tice.api.client.parsers;

import java.util.List;

import com.fasterxml.jackson.core.type.TypeReference;
import com.fasterxml.jackson.databind.DeserializationFeature;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.n0tice.api.client.exceptions.ParsingException;
import com.n0tice.api.client.model.HistoryItem;

public class HistoryParser {
	
	private ObjectMapper mapper;

	public HistoryParser() {
		mapper = new ObjectMapper();
		mapper.configure(DeserializationFeature.FAIL_ON_UNKNOWN_PROPERTIES,
				false);
	}
	
	public List<HistoryItem> parse(String json) throws ParsingException {
		try {
			return mapper.readValue(json, new TypeReference<List<HistoryItem>>(){});			
		} catch (Exception e) {
			throw new ParsingException(e.getMessage());
		}
	}
	
}
