package com.n0tice.api.client.parsers;

import com.fasterxml.jackson.databind.DeserializationFeature;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.n0tice.api.client.exceptions.ParsingException;
import com.n0tice.api.client.model.MediaInfo;

public class MediaInfoParser {

	private ObjectMapper mapper;
	
	public MediaInfoParser() {
		mapper = new ObjectMapper();
        mapper.configure(DeserializationFeature.FAIL_ON_UNKNOWN_PROPERTIES, false);
	}
	
	public MediaInfo parse(String json) throws ParsingException {
		try {
			return mapper.readValue(json, MediaInfo.class);
		} catch (Exception e) {
			throw new ParsingException(e.getMessage());
		}
	}

}
