package com.n0tice.api.client.parsers;

import java.util.List;

import com.fasterxml.jackson.core.type.TypeReference;
import com.fasterxml.jackson.databind.DeserializationFeature;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.n0tice.api.client.exceptions.ParsingException;
import com.n0tice.api.client.model.FlagType;
import com.n0tice.api.client.model.ModerationAction;
import com.n0tice.api.client.model.ModerationComplaint;
import com.n0tice.api.client.model.ModerationState;

public class ModerationComplaintParser {
	
	private ObjectMapper mapper;
	
	public ModerationComplaintParser() {
		mapper = new ObjectMapper();
        mapper.configure(DeserializationFeature.FAIL_ON_UNKNOWN_PROPERTIES, false);
	}
	
	public List<ModerationComplaint> parse(String json) throws ParsingException {
		try {
			return mapper.readValue(json, new TypeReference<List<ModerationComplaint>>(){});			
		} catch (Exception e) {
			throw new ParsingException(e.getMessage());
		}
	}
	
	public List<ModerationState> parseModerationStates(String json) throws ParsingException {
		try {
			return mapper.readValue(json, new TypeReference<List<ModerationState>>(){});			
		} catch (Exception e) {
			throw new ParsingException(e.getMessage());
		}
	}
	
	public List<ModerationAction> parseModerationActions(String json) throws ParsingException {
		try {
			return mapper.readValue(json, new TypeReference<List<ModerationAction>>(){});			
		} catch (Exception e) {
			throw new ParsingException(e.getMessage());
		}
	}
	
	public List<FlagType> parseFlagTypes(String json) throws ParsingException {
		try {
			return mapper.readValue(json, new TypeReference<List<FlagType>>(){});			
		} catch (Exception e) {
			throw new ParsingException(e.getMessage());
		}
	}
	
}
