package com.n0tice.api.client.parsers;

import java.util.List;

import com.fasterxml.jackson.core.type.TypeReference;
import com.fasterxml.jackson.databind.DeserializationFeature;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.n0tice.api.client.exceptions.ParsingException;
import com.n0tice.api.client.model.Noticeboard;
import com.n0tice.api.client.model.NoticeboardResultSet;

public class NoticeboardParser {
	
	private ObjectMapper mapper;
	
	public NoticeboardParser() {
		mapper = new ObjectMapper();
        mapper.configure(DeserializationFeature.FAIL_ON_UNKNOWN_PROPERTIES, false);
	}
	
	public List<Noticeboard> parseNoticeboards(String json) throws ParsingException {
		try {
			return mapper.readValue(json, new TypeReference<List<Noticeboard>>(){});
		} catch (Exception e) {
			throw new ParsingException(e.getMessage());
		}
	}
	
	public Noticeboard parseNoticeboardResult(String json) throws ParsingException {
		try {
			return mapper.readValue(json, Noticeboard.class);
		} catch (Exception e) {
			throw new ParsingException(e.getMessage());
		}
	}
	
	public NoticeboardResultSet parseNoticeboardSearchResults(String json) throws ParsingException {
		try {
			return mapper.readValue(json, NoticeboardResultSet.class);
		} catch (Exception e) {
			throw new ParsingException(e.getMessage());
		}
	}
	
}
