package com.n0tice.api.client.parsers;

import java.util.List;

import com.fasterxml.jackson.core.type.TypeReference;
import com.fasterxml.jackson.databind.DeserializationFeature;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.n0tice.api.client.exceptions.ParsingException;
import com.n0tice.api.client.model.AuthResponse;
import com.n0tice.api.client.model.NewUserResponse;
import com.n0tice.api.client.model.User;

public class UserParser {
	
	private ObjectMapper mapper;
		
	public UserParser() {
		mapper = new ObjectMapper();
        mapper.configure(DeserializationFeature.FAIL_ON_UNKNOWN_PROPERTIES, false);	}
		
	public User parseUserProfile(String json) throws ParsingException {
		try {
			return mapper.readValue(json, User.class);			
		} catch (Exception e) {
			throw new ParsingException(e.getMessage());
		}
	}
	
	public List<User> parseUserProfiles(String json) throws ParsingException {
		try {
			return mapper.readValue(json, new TypeReference<List<User>>(){});			
		} catch (Exception e) {
			throw new ParsingException(e.getMessage());
		}
	}
	
	public NewUserResponse parseNewUserResponse(String json) throws ParsingException {
		try {
			return mapper.readValue(json, NewUserResponse.class);			
		} catch (Exception e) {
			throw new ParsingException(e.getMessage());
		}
	}
		
	public AuthResponse parseAuthUserResponse(String json) throws ParsingException {
		try {
			return mapper.readValue(json, AuthResponse.class);
		} catch (Exception e) {
			throw new ParsingException(e.getMessage());
		}
	}
	
}
