package com.n0tice.api.client.parsers;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertFalse;

import java.util.List;

import org.junit.Before;
import org.junit.Test;

import com.n0tice.api.client.model.ModerationAction;
import com.n0tice.api.client.model.ModerationState;

public class ModerationComplaintParserTest {
	
	private ModerationComplaintParser parser;
	
	@Before
	public void setup() {
		this.parser = new ModerationComplaintParser();
	}

	@Test
	public void canParseModerationActions() throws Exception {
		final List<ModerationAction> actions = parser.parseModerationActions(ContentLoader.loadContent("moderationActions.json"));
		
		assertEquals(5, actions.size());
		assertEquals("DEFER", actions.get(1).getId());
		assertEquals("Defer", actions.get(1).getLabel());
		assertEquals("DEFERED", actions.get(1).getStatus().getId());
	}
	
	@Test
	public void canParseModerationStates() throws Exception {		
		final List<ModerationState> states = parser.parseModerationStates(ContentLoader.loadContent("moderationStates.json"));

		assertEquals(6, states.size());
		assertEquals("QUERY_LEGAL", states.get(2).getId());
		assertEquals("Querying legal", states.get(2).getLabel());
		assertFalse(states.get(2).isLive());
	}

}
